#ifndef _SYSMNGMT_
#define _SYSMNGMT_
#include "mbed.h"

#define MSEC_HRS 2.77778e-7
#define DC_DC_ISENSE_OFFSET_V 0.5
#define DC_DC_ISENSE_INCREMENT 0.133

#define BAT_ISENSE_OFFSET_V 1.65
#define BAT_ISENSE_INCREMENT 0.5297
    
Serial pc(USBTX,USBRX);
CAN CAN_SysM(p30,p29);

//Temperature Input
AnalogIn Coolant1(p17); //Brass ones
AnalogIn Coolant2(p16); //Brass ones
AnalogIn DC_DC(p18);    //Murata
AnalogIn ChargerFET(p15);//Murata
AnalogIn BatISense(p19);
AnalogIn DCSense(p20);

typedef union convert{
        float FLOAT;
        char C_FLOAT[4];
        }ftc;

// Call function at reccuring interval
Ticker ReadIMD, PollSDSwitch, ReadTemperature, ReadBatteryState;

double BATmA_Hr;
float DCA_msec,BATA_msec;
float Bat_I_Ratio,DC_I_Ratio;
CANMessage RxBuffer[10]={};

/*
PwmOut Pump(p26);
PwmOut Fan1(p25);
PwmOut Fan2(p24);
PwmOut Fan3(p23);
*/
#endif /* _SYSMNGMT_ */